theory Sum
imports "../TermFun"
begin

fun hd :: "nat list \<Rightarrow> nat" where
  "hd [] = 0" (* underspecification not supported *)
| "hd (x#xs) = x"

fun null :: "'a list \<Rightarrow> bool" where
  "null [] = True"
| "null _  = False"

function sum :: "nat list \<Rightarrow> nat" where
  "sum xs = (if null xs then 0
                        else hd xs + sum (tl xs))"
  by pat_completeness auto

define_trs null.simps
define_trs tl.simps
define_trs hd.simps
define_trs (no_sim) sum.psimps

termination sum
  apply (trs_reduce sum)
  apply (simp only: all_trs_defs set_list_conv)
  export_termination_problem "sum.xml"
  apply (ceta_import_proof "proofs/sum.proof.xml")
  apply ceta_eval
done

end
